{$M 16384,16384,650000}

Uses Dos,Crt,Graph;

{$I+}

Const NameSize=15; MaxRuns=10;

Type
  NamesPt   = ^NameType;         AttrsPt   = ^AttrType;  SizesPt   = ^SizeType;
  NameType  = String[NameSize];  AttrType  = Byte;       SizeType  = LongInt;

Var
  RegS:Registers;
  Attribute,LineCount,X,ForeGrn,BckGrn,Width:Byte;
  Y,Count:Integer;
  Temp,Temp2,SearchPattern,S:String;
  Found:SearchRec;
  Runs :Array [0..MaxRuns] of String;
  Names:Array [0..600] of NamesPt;  Attrs:Array [0..600] of AttrsPt;
  Sizes:Array [0..600] of SizesPt;
  Prog,Redir:Boolean; A:Char;

Procedure Color(F,B:Byte);
 Begin
   If Redir then Exit;
   TextColor(F); TextBackGround(B and 15);
  End;

Procedure FindEnviron(S:String;var PSPS,PSPO:Word);
 Var Count:Integer; Found:Boolean;
 Begin
   For Count:=1 to Length(S) do S[Count]:=UpCase(S[Count]);
   S:=S+'=';
   PSPO:=0; PSPS:=MemW[CSeg-$10:$2C];
   Count:=1; Found:=False;
   While (Count<=Length(S)) and (PSPO<32768) do Begin
     If S[Count]<>Chr(Mem[PSPS:PSPO]) then Begin
       Count:=1; While (PSPO<32768) and (Mem[PSPS:PSPO]<>0) do Inc(PSPO);
       If (PSPO>=32768) then Found:=False  Else Begin
         Inc(PSPO); If Mem[PSPS:PSPO]=0 then Begin
           PSPO:=$FFFF; Found:=False;
          End;
        End;
      End Else Begin
        Inc(Count); Inc(PSPO);
       End;
    End;
   If Count>Length(S) then Found:=True  Else Found:=False;
   If Not Found then Begin
     PSPS:=0; PSPO:=0;
    End Else Begin
      While (PSPO>0) and (Mem[PSPS:PSPO]<>0) do Dec(PSPO);
      If Mem[PSPS:PSPO]=0 then Inc(PSPO);
     End;
  End;

Function GetEnviron(S:String):String;
 Var Se,OOf:Word; St:String; T:Integer;
 Begin
   FindEnviron(S,Se,OOf);
   If Se<>0 then Begin
     St:=''; While (Mem[Se:OOf]<>Ord('=')) and (OOf<32768) do Inc(OOf);
     Inc(OOf);
     While (Mem[Se:OOf]<>0) and (OOf<32768) do Begin
       St:=St+Chr(Mem[Se:OOf]); Inc(OOf);
      End;
    End Else St:='';
   GetEnviron:=St;
  End;

Procedure GetRuns;
 Var S:String; T,X:Word;
 Begin
   For T:=0 to MaxRuns do Runs[T]:='';
   S:=GetEnviron('RUN'); If S='' then Begin
     Runs[0]:='*.COM';
     Runs[1]:='*.BAT';
     Runs[3]:='*.EXE';
    End Else Begin
      X:=0; Repeat
        T:=Pos(';',S); If T=0 then T:=Length(S)+1;
        Runs[X]:=Copy(S,1,T-1); X:=X+1;
        S:=Copy(S,T+1,255);
       Until S='';
     End;
   For T:=0 to MaxRuns do Begin
     If Runs[T]>'' then Begin
       X:=Pos('.',Runs[T]);  If X=0 then Begin X:=1; Runs[T]:='.'+Runs[T]; End;
       Runs[T]:=Copy(Runs[T],X,4);
       For X:=1 to Length(Runs[T]) do Runs[T][X]:=UpCase(Runs[T][X]);
      End;
    End;
  End;

Procedure Colors(Var Fore,Back:Byte);
 Var Z,X,Y,PrevVal:Word;
 Const MrkX=1; MrkY=25; MrkW=80; ModeSeg=$40; ModeOff=$49;
 Begin
   ReDir:=False;
   If Mem[ModeSeg:ModeOff]=7 then Z:=$B000  Else Z:=$B800;
   PrevVal:=Mem[Z:(MrkY-1)*MrkW*2+(MrkX-1)]; X:=WhereX; Y:=WhereY;
   GotoXY(MrkX,MrkY); Regs.AH:=2; Regs.DL:=$FF; MSDOS(Regs);
   If (WhereX=MrkX) and (WhereY=MrkY) then Begin
     Redir:=True; DirectVideo:=False;
    End Else Begin
      If Mem[Z:(MrkY-1)*MrkW*2+(MrkX-1)]=$FF then
       DirectVideo:=True
      Else
       DirectVideo:=False;
     End;
   GotoXY(X,Y); Mem[Z:(MrkY-1)*MrkW*2+(MrkX-1)]:=PrevVal;
   If ReDir then Begin Assign(Output,''); ReWrite(OutPut); End;
   Assign(Input,''); Reset(Input);
   If Not Redir then Begin
     Fore:=(TextAttr and $0F);
     If (TextAttr and $80)>0 then Fore:=Fore+Blink;
     Back:=(TextAttr and $F0) shr 4;
     Color(Fore,Back);
    End;
 End;

Function Cln(S:String):String;
 Var X:Byte;
 Begin
   X:=0; While (S>'') and (X=0) do
    If Copy(S,1,1)=' 'then Delete(S,1,1) Else X:=90;
   X:=0; While (S>'') and (X=0) do
    If Copy(S,Length(S),1)=' 'then Delete(S,Length(S),1) Else X:=90;
   CLN:=S;
  End;

Procedure ChkStop;
 Var T:Registers;
 Begin
   T.AX:=$0100; Intr($16,T);
   If (T.Flags And FCarry)=0 then Exit;
   If Lo(Regs.AX)=3 then Halt;
  End;

Procedure BWrite(A:String);
 Begin
   If Not Redir then Color(BckGrn{+Blink},ForeGrn);
   Write(A); If Not Redir then Color(ForeGrn,BckGrn);
  End;

Function ErrorName(P:Byte):String;
 Var Mess:String;
 Begin
   Case P of
      0: Mess:='';                   2: Mess:='File not found';
      3: Mess:='Path not found';    15: Mess:='Drive invalid';
     18: Mess:='No more files';     21: Mess:='Drive not ready';
      Else Begin
        Str(P,Mess); Mess:='Abnormal error dos # '+Mess;
       End;
    End; {Case}
   ErrorName:=Mess;
  End;

Procedure EHalt(Rt:Byte);
 Begin
   Y:=DosError; If Y=0 then Exit;
   Writeln(''); Writeln(' ERROR ---- '+ErrorName(Y)+'   *Routine: ',Rt);
   Halt;
  End;

Procedure GetAtt;
 Begin
   GetRuns;
   For Y:=1 to Length(SearchPattern) Do
     SearchPattern[Y]:=UpCase(SearchPattern[Y]);
   Y:=Pos('/',SearchPattern);
   If Y>0 then Begin
     Case SearchPattern[Y+1] of
       'R': Attribute:=1;  'S': Attribute:=4;  'V': Attribute:=8;
       'D': Attribute:=16; 'H': Attribute:=2;  'X': Attribute:=255;
       'A': Attribute:=32; 'N': Attribute:=0   Else Attribute:=255;
      End; {Case}
     If SearchPattern[Y+1]='P' then Prog:=True   Else  Prog:=False;
     Delete(SearchPattern,Y,250);
    End Else Begin
      Attribute:=255; Prog:=False;
     End;
   SearchPattern:=Cln(SearchPattern);
  End;

Function InStr(X:Integer;Source,FindStr:String):Integer;
 Var A,B,Y:Integer;
 Begin
   A:=0; B:=Length(FindStr); If X=0 then X:=1;
   If X<0 then Begin
     X:=Abs(X); For Y:=1 to Length(Source) do Source[Y]:=UpCase(Source[Y]);
     For Y:=1 to Length(FindStr) do FindStr[Y]:=UpCase(FindStr[Y]);
    End;
   Y:=X; While Y<=Length(Source) do Begin
     If Copy(Source,Y,B)=FindStr then Begin A:=Y; Y:=254; End;
     Y:=Y+1;
    End;
   InStr:=A;
  End;

Function EndPath(Name:String):Byte;
 Begin
   Y:=0; Count:=0;
   While Y<>255 do Begin
     Y:=Instr(Count+1,Name,'\'); If Y>0 then Count:=Y;
     If Y=0 then Y:=255;
    End; If Y=255 then Y:=0;
   If Count=0 then Count:=Pos(':',Name);
   EndPath:=Count;
  End;

Function DoStr(Num:Real;Y:Integer):String;
 Var S:String; X:Integer;
 Begin
   Str(Num:0:0,S); X:=Length(S);
   If X>9 then S:=Copy(S,1,X-9)+','+Copy(S,X-8,3)+','+Copy(S,X-6,3)+','+Copy(S,X-5,3)+','+Copy(S,X-2,30)
   Else If X>6 then S:=Copy(S,1,X-6)+','+Copy(S,X-5,3)+','+Copy(S,X-2,30)
    Else If X>3 then S:=Copy(S,1,X-3)+','+Copy(S,X-2,30);
   While Length(S)<Y do S:=' '+S;
   DoStr:=S
  End;

Procedure CaseAtt(X:Byte;Var A:Char);
 Begin
   If X=0 then A:='N';
   If (X and $20)>0 then A:='A';    If (X and $01)>0 then A:='R';
   If (X and $10)>0 then A:='D';    If (X and $02)>0 then A:='H';
   If (X and $08)>0 then A:='V';    If (X and $04)>0 then A:='S';
   If X=$FF then Begin A:='X'; If Prog then A:='P'; End;
  End;

Procedure Initial;
 Begin
   Regs.AX:=$0D00; MsDos(Regs);                             {Reset drives}
   X:=EndPath(SearchPattern);
   Temp:=Copy(SearchPattern,1,X); S:=Copy(SearchPattern,X+1,254);
   If Instr(0,Temp,':')<>2 then Begin                       {Get drive letter}
     Regs.AX:=$1900; MsDos(Regs);
     Temp:=Chr(Lo(Regs.AX)+65)+':'+Temp;
    End;
   If Instr(0,Temp,'\')<>3 then Begin                       {Get entire path}
     Mem[Seg(Temp2):Ofs(Temp2)]:=64;
     Regs.DX:=Ord(Temp[1])-64; Regs.AX:=$4700;
     Regs.DS:=Seg(Temp2); Regs.SI:=Ofs(Temp2)+1;
     MsDos(Regs); If (Regs.Flags and FCarry)>0 then Begin
       If Regs.AX=15 then
         Writeln(' Error -- DOS does not recognize drive '+Temp[1]+':')  Else
         Writeln(' Error -- DOS cannot read drive '+Temp[1]+':'); Halt;
      End;
     Mem[Seg(Temp2):Ofs(Temp2)]:=Instr(0,Temp2,#0)-1;
     Temp2:='\'+Temp2; Insert(Temp2,Temp,3);
    End;
   If Temp[Length(Temp)]<>'\' then S:='\'+S;
   WriteLn(''); Write(' Pattern: '+Temp+S+' '); CaseAtt(Attribute,A);
   Color(BckGrn or Blink,ForeGrn);
   Write(A); Color(ForeGrn,BckGrn);
   GotoXY(40,WhereY); Write(' Free: ');
   Write(DoStr(DiskFree(Ord(Temp[1])-64),11));
   WriteLn(' bytes'); LineCount:=LineCount+1;
   WriteLn('Ŀ');
   LineCount:=LineCount+1; ChkStop;
  End;

Procedure Sort;
 Var X,Y:Integer; C:Char;
 Begin
   If (Attribute=0) and (Found.Attr>0) then Exit;
   If (Found.Attr and Attribute)=0 then               { no matched bits }
    If (Attribute>0) and (Attribute<255) then Exit;   { We should have caught bits }
   If (Found.Name='.') or (Found.Name='..') then Exit;{ Not interested in Dir data }
   If Prog then Begin
      Y:=90; For X:=0 to MaxRuns do
       If (Runs[X]>'') and (Pos(Runs[X],Found.Name)>0) then Y:=0;
      If Y<>0 then Exit;
    End;

   Y:=-1; X:=0; While X<Count do Begin
     If Found.Name<Names[X]^ then Begin
       For Y:=Count DownTo X do Begin
         Names[Y]^:=Names[Y-1]^;
         Attrs[Y]^:=Attrs[Y-1]^;
         Sizes[Y]^:=Sizes[Y-1]^;
        End;
      Y:=X; X:=Count; End;
    X:=X+1; End;
   If Y>=0 then X:=Y  Else  X:=Count;
   Names[X]^:=Found.Name; Attrs[X]^:=Found.Attr; Sizes[X]^:=Found.Size;
   Count:=Count+1; New(Names[Count]); New(Attrs[Count]); New(Sizes[Count]);
  End;

Procedure WriteOneName(TheName:String; Num:Integer);
 Var X,T:Byte; A:Char; S:String;
 Begin
   X:=Instr(0,TheName,'.'); ChkStop;
   If X=0 then X:=Length(TheName)+1;
   Write(''+Copy(TheName,1,X-1)); For T:=X to 8 do Write(' ');
   Write('.'); If X>Length(TheName) then X:=Length(TheName);
   Write(Copy(TheName+'    ',X+1,3));
   CaseAtt(Attrs[Num]^,A);
   Str(Sizes[Num]^/1:4:0,S); If Length(S)>4 then Begin
     Str(Sizes[Num]^/1024:3:0,S); If Length(S)<4 then S:=S+'k'  Else  Begin
       Str(Sizes[Num]^/(1024*1024):3:0,S); S:=S+'m';
      End
    End;
   BWrite(A); Write(' '+S); Inc(Width);
   If Width>4 then Begin
     LineCount:=LineCount+1; WriteLn(''); Width:=1;
     If (LineCount>23) and (Not Redir) then Begin
       Color(15+Blink,0);
       Write('-----More------'+#7); A:=ReadKey; Writeln;
       LineCount:=0; Color(ForeGrn,BckGrn);
      End;
    End;
  End;

Procedure GetNames;
 Var X:Integer; OutName:NameType;
 Begin
   Color(15+Blink,0); If Not Redir then Write(' Wait - accessing');
   GotoXY(1,WhereY); Color(ForeGrn,BckGrn);
   FindFirst(SearchPattern,Attribute,Found); Ehalt(2);
   While DosError=0 do Begin
     If (MemAvail-NameSize*2)>0 then Sort  Else  Begin
       Writeln(''); Writeln(' Error -- You don'+#39+'t have enough memory to finish!');
       LineCount:=LineCount+2; Exit;
      End;
     FindNext(Found);
    End;
  End;

Begin
  Colors(ForeGrn,BckGrn);
   LineCount:=2; SearchPattern:=ParamStr(1)+' '+ParamStr(2);
  Attribute:=255; GetAtt;
  New(Names[0]); New(Attrs[0]); New(Sizes[0]);
  If EndPath(SearchPattern)=Length(SearchPattern) then
      SearchPattern:=SearchPattern+'*.*'
   Else
    If (Pos('*',SearchPattern)=0) and
       (Pos('?',SearchPattern)=0) then Begin
          FindFirst(SearchPattern,$10,Found);
          If DosError=0 then SearchPattern:=SearchPattern+'\*.*';
         End;
  If Pos('.',SearchPattern)=0 then Searchpattern:=Searchpattern+'.*';
  Initial; Count:=0; GetNames; If Count=0 then EHalt(5);
  Width:=1;
  For X:=0 to Count-1 do WriteOneName(Names[X]^,X);
  If Width>1 then Begin                                     { Fill in blanks }
    While Width<5 do Begin Write('                  '); Inc(Width); End;
    If Width<6 then Begin Writeln(''); Inc(Width); End;
   End;
  WriteLn('');
  Write(' '); BWrite('A'); Write(' Needs Archived ');
  BWrite('N'); Write(' Normal ');  BWrite('R'); Write(' Read only ');
  BWrite('S'); Write(' System ');  BWrite('V'); Write(' Volume ');
  BWrite('H'); Write(' Hidden ');  BWrite('D'); Write(' Subdir ');
 End.
